window.Gleam.initSearch([{"doc":"signal_pgo","title":"signal_pgo","content":"# signal_pgo\n\n[![Package Version](https://img.shields.io/hexpm/v/postgres_persistance)](https://hex.pm/packages/signal_pgo)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/signal_pgo/)\n\n```sh\ngleam add signal_pgo\n```\n\nThis is a persistance layer for the signal event sourcing library, on application startup, it will run migrations to set up an events table, and then it will be able to store and load events from signal. To configure it, you need to provide a gleam_pgo config, as well as an encoder and decoder for your events.\n\nThe encoding and decoding is done to a String, because event data is stored as a TEXT field in postgres. This also allows for maximum flexibility, allowing you to control exactly how data is stored.\n\nThis flexibility lets you implement things like encryption, or avoid the performance overhead of JSON parsing.\n\n## Usage\n\nSet up a local database:\n\n```sh\ndocker run --name your-db-name -e POSTGRES_USER=postgres -e POSTGRES_PASSWORD=postgres -p 5500:5432 -d postgres\n```\n\nSet up the persistance layer:\n\n```gleam\nimport signal\nimport signal_pgo\n\npub fn main() {\n\n  let event_encoder = my_event_encoder\n  let event_decoder = my_event_decoder\n\n  // TODO: An example of the project in use\n  ...\n```\n\nSet up the persistance layer:\n\n```gleam\n  ...\n\n  let event_encoder = my_event_encoder\n  let event_decoder = my_event_decoder\n\n  // TODO: An example of the project in use\n  ...\n```\n\nPlug it into your signal instance:\n\n```gleam\n  ...\n\n  // TODO: An example of the project in use\n}\n```\n","url":"index.html"},{"doc":"signal_pgo","title":"start","content":"pub fn start(\n  pgo_config: Config,\n  event_encoder: fn(a) -&gt; String,\n  event_decoder: fn(String, String) -&gt; a,\n) -&gt; Result(Subject(PersistanceMessage(a)), StartError)\n\nSynonyms:\nsignal_pgo.start\nsignal_pgo start","url":"signal_pgo.html#start"},{"doc":"signal_pgo","title":"signal_pgo","content":"","url":"signal_pgo.html"}]);